import type { FieldConfiguration, Filter, FilterValue, FilterValueRange, QueryConfig, RequestState, SearchFieldConfiguration } from "@elastic/search-ui";
import { BaseFilters, SearchkitConfig } from "@searchkit/sdk";
import type { PostProcessRequestBodyFn } from "../../types";
export declare function getResultFields(resultFields: Record<string, FieldConfiguration>): {
    hitFields: string[];
    highlightFields: string[];
};
export declare function getQueryFields(searchFields?: Record<string, SearchFieldConfiguration>): string[];
export declare function isRangeFilter(filterValue: FilterValue): filterValue is FilterValueRange;
export declare function buildBaseFilters(baseFilters: Filter[]): BaseFilters;
declare function buildConfiguration(state: RequestState, queryConfig: QueryConfig, host: string, index: string, apiKey: string, postProcessRequestBodyFn?: PostProcessRequestBodyFn): SearchkitConfig;
export default buildConfiguration;
