export function getFilters(filters = [], baseFilters = []) {
    return filters.reduce((acc, f) => {
        const isBaseFilter = baseFilters.find((bf) => bf === f);
        if (isBaseFilter)
            return acc;
        const subFilters = f.values.map((v) => ({
            identifier: f.field,
            value: v
        }));
        return [...acc, ...subFilters];
    }, []);
}
function SearchRequest(state, queryConfig) {
    var _a;
    return {
        query: state.searchTerm,
        filters: state.filters
            ? getFilters(state.filters, queryConfig.filters)
            : [],
        from: (state.current - 1) * state.resultsPerPage,
        size: state.resultsPerPage,
        sort: ((_a = state.sortList) === null || _a === void 0 ? void 0 : _a.length) > 0 ? "selectedOption" : null
    };
}
export default SearchRequest;
